/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.model;

import java.util.Comparator;
import org.openide.util.NbBundle;

/**
 * Enum which holds ISO 3166-1 country codes The name of the country is coming
 * from a bundle file
 *
 * @author Merijn Zengers
 */
@NbBundle.Messages({"Country AF=Afghanistan",
    "Country AX=Åland Islands",
    "Country AL=Albania",
    "Country DZ=Algeria",
    "Country AS=American Samoa",
    "Country AD=Andora",
    "Country AO=Angola",
    "Country AI=Anguilla",
    "Country AQ=Antartica",
    "Country AG=Antigua and Barbuda",
    "Country AR=Argentina",
    "Country AM=Armenia",
    "Country AW=Aruba",
    "Country AU=Australia",
    "Country AT=Austia",
    "Country AZ=Azerbaijan",
    "Country BS=Bahamas",
    "Country BH=Bahrain",
    "Country BD=Bangladesh",
    "Country BB=Barbados",
    "Country BY=Belarus",
    "Country BE=Belgium",
    "Country BZ=Belize",
    "Country BJ=Benin",
    "Country BM=Bermuda",
    "Country BT=Bhutan",
    "Country BO=Bolivia, Plurinational State of",
    "Country BQ=Bonaire, Sint Eustatius and Saba",
    "Country BA=Bosnia and Herzegovina",
    "Country BW=Botswana",
    "Country BV=Bouvet Island",
    "Country BR=Brazil",
    "Country IO=British Indian Ocean Territory",
    "Country BN=Brunei Darussalam",
    "Country BG=Bulgaria",
    "Country BF=Burkina Faso",
    "Country BI=Burundi",
    "Country KH=Cambodia",
    "Country CM=Cameroon",
    "Country CA=Canada",
    "Country CV=Cape Verde",
    "Country KY=Cayman Islands",
    "Country CF=Central African Republic",
    "Country TD=Chad",
    "Country CL=Chile",
    "Country CN=China",
    "Country CX=Cristmas Islands",
    "Country CC=Cocos (Keeling) Islands",
    "Country CO=Colombia",
    "Country KM=Comoros",
    "Country CG=Congo",
    "Country CD=Congo, the Democratic Republic of the",
    "Country CK=Cook Islands",
    "Country CR=Costa Rica",
    "Country CI=Côte d'Ivoire",
    "Country HR=Croatia",
    "Country CU=Cuba",
    "Country CW=Curaçao",
    "Country CY=Cyprus",
    "Country CZ=Czech Republic",
    "Country DK=Denmark",
    "Country DJ=Djibouti",
    "Country DM=Dominica",
    "Country DO=Dominican Republic",
    "Country EC=Ecuador",
    "Country EG=Egypt",
    "Country SV=El Salvador",
    "Country GQ=Equatorial Guinea",
    "Country ER=Eritrea",
    "Country EE=Estonia",
    "Country ET=Ethiopia",
    "Country FK=Falkland Islands (Malvinas)",
    "Country FO=Faroe Islands",
    "Country FJ=Fiji",
    "Country FI=Finland",
    "Country FR=France",
    "Country GF=French Guiana",
    "Country PF=French Polynesia",
    "Country TF=French Southern Territories",
    "Country GA=Gabon",
    "Country GM=Gambia",
    "Country GE=Georgia",
    "Country DE=Germany",
    "Country GH=Ghana",
    "Country GI=Gibraltar",
    "Country GR=Greece",
    "Country GL=Greenland",
    "Country GD=Grenada",
    "Country GP=Guadeloupe",
    "Country GU=Guam",
    "Country GT=Guatemala",
    "Country GG=Guernsey",
    "Country GN=Guinea",
    "Country GW=Guinea-Bissau",
    "Country GY=Guyana",
    "Country HT=Haiti",
    "Country HM=Heard Island and McDonald Islands",
    "Country VA=Holy See (Vatican City State)",
    "Country HN=Honduras",
    "Country HK=Hong Kong",
    "Country HU=Hungary",
    "Country IS=Iceland",
    "Country IN=India",
    "Country ID=Indonesia",
    "Country IR=Iran, Islamic Republic of",
    "Country IQ=Iraq",
    "Country IE=Ireland",
    "Country IM=Isle of Man",
    "Country IL=Israel",
    "Country IT=Italy",
    "Country JM=Jamaica",
    "Country JP=Japan",
    "Country JE=Jersey",
    "Country JO=Jordan",
    "Country KZ=Kazakhstan",
    "Country KE=Kenya",
    "Country KI=Kiribati",
    "Country KP=Korea, Democratic People's Republic of",
    "Country KR=Korea, Republic of",
    "Country KW=Kuwait",
    "Country KG=Kyrgyzstan",
    "Country LA=Lao People's Democratic Republic",
    "Country LV=Latvia",
    "Country LB=Lebanon",
    "Country LS=Lesotho",
    "Country LR=Liberia",
    "Country LY=Libya",
    "Country LI=Liechtenstein",
    "Country LT=Lithuania",
    "Country LU=Luxembourg",
    "Country MO=Macao",
    "Country MK=Macedonia, the former Yugoslav Republic of",
    "Country MG=Madagascar",
    "Country MW=Malawi",
    "Country MY=Malaysia",
    "Country MV=Maldives",
    "Country ML=Mali",
    "Country MT=Malta",
    "Country MH=Marshall Islands",
    "Country MQ=Martinique",
    "Country MR=Mauritania",
    "Country MU=Mauritius",
    "Country YT=Mayotte",
    "Country MX=Mexico",
    "Country FM=Micronesia, Federated States of",
    "Country MD=Moldova, Republic of",
    "Country MC=Monaco",
    "Country MN=Mongolia",
    "Country ME=Montenegro",
    "Country MS=Montserrat",
    "Country MA=Morocco",
    "Country MZ=Mozambique",
    "Country MM=Myanmar",
    "Country NA=Namibia",
    "Country NR=Nauru",
    "Country NP=Nepal",
    "Country NL=Netherlands",
    "Country NC=New Caledonia",
    "Country NZ=New Zealand",
    "Country NI=Nicaragua",
    "Country NE=Niger",
    "Country NG=Nigeria",
    "Country NU=Niue",
    "Country NF=Norfolk Island",
    "Country MP=Northern Mariana Islands",
    "Country NO=Norway",
    "Country OM=Oman",
    "Country PK=Pakistan",
    "Country PW=Palau",
    "Country PS=Palestinian Territory, Occupied",
    "Country PA=Panama",
    "Country PG=Papua New Guinea",
    "Country PY=Paraguay",
    "Country PE=Peru",
    "Country PH=Philippines",
    "Country PN=Pitcairn",
    "Country PL=Poland",
    "Country PT=Portugal",
    "Country PR=Puerto Rico",
    "Country QA=Qatar",
    "Country RE=Réunion",
    "Country RO=Romania",
    "Country RU=Russian Federation",
    "Country RW=Rwanda",
    "Country BL=Saint Barthélemy",
    "Country SH=Saint Helena, Ascension and Tristan da Cunha",
    "Country KN=Saint Kitts and Nevis",
    "Country LC=Saint Lucia",
    "Country MF=Saint Martin (French part)",
    "Country PM=Saint Pierre and Miquelon",
    "Country VC=Saint Vincent and the Grenadines",
    "Country WS=Samoa",
    "Country SM=San Marino",
    "Country ST=Sao Tome and Principe",
    "Country SA=Saudi Arabia",
    "Country SN=Senegal",
    "Country RS=Serbia",
    "Country SC=Seychelles",
    "Country SL=Sierra Leone",
    "Country SG=Singapore",
    "Country SX=Sint Maarten (Dutch part)",
    "Country SK=Slovakia",
    "Country SI=Slovenia",
    "Country SB=Solomon Islands",
    "Country SO=Somalia",
    "Country ZA=South Africa",
    "Country GS=South Georgia and the South Sandwich Islands",
    "Country SS=South Sudan",
    "Country ES=Spain",
    "Country LK=Sri Lanka",
    "Country SD=Sudan",
    "Country SR=Suriname",
    "Country SJ=Svalbard and Jan Mayen",
    "Country SZ=Swaziland",
    "Country SE=Sweden",
    "Country CH=Switzerland",
    "Country SY=Syrian Arab Republic",
    "Country TW=Taiwan, Province of China",
    "Country TJ=Tajikistan",
    "Country TZ=Tanzania, United Republic of",
    "Country TH=Thailand",
    "Country TL=Timor-Leste",
    "Country TG=Togo",
    "Country TK=Tokelau",
    "Country TO=Tonga",
    "Country TT=Trinidad and Tobago",
    "Country TN=Tunisia",
    "Country TR=Turkey",
    "Country TM=Turkmenistan",
    "Country TC=Turks and Caicos Islands",
    "Country TV=Tuvalu",
    "Country UG=Uganda",
    "Country UA=Ukraine",
    "Country AE=United Arab Emirates",
    "Country GB=United Kingdom",
    "Country US=United States",
    "Country UM=United States Minor Outlying Islands",
    "Country UY=Uruguay",
    "Country UZ=Uzbekistan",
    "Country VU=Vanuatu",
    "Country VE=Venezuela, Bolivarian Republic of",
    "Country VN=Viet Nam",
    "Country VG=Virgin Islands, British",
    "Country VI=Virgin Islands, U.S.",
    "Country WF=Wallis and Futuna",
    "Country EH=Western Sahara",
    "Country YE=Yemen",
    "Country ZM=Zambia",
    "Country ZW=Zimbabwe"})
public enum Country {
    /**
     * Empty
     */
    EMPTY("", "", "", ""),
    /**
     * Afghanistan
     */
    AF("AF", "AFG", "004", "ISO 3166-2:AF"),
    /**
     * Åland Islands
     */
    AX("AX", "ALA", "248", "ISO 3166-2:AX"),
    /**
     * Albania
     */
    AL("AL", "ALB", "008", "ISO 3166-2:AL"),
    /**
     * Algeria
     */
    DZ("DZ", "DZA", "012", "ISO 3166-2:DZ"),
    /**
     * American Samoa
     */
    AS("AS", "ASM", "016", "ISO 3166-2:AS"),
    /**
     * Andora
     */
    AD("AD", "AND", "020", "ISO 3166-2:AD"),
    /**
     * Angola
     */
    AO("AO", "AGO", "024", "ISO 3166-2:AO"),
    /**
     * Anguilla
     */
    AI("AI", "AIA", "660", "ISO 3166-2:AI"),
    /**
     * Antartica
     */
    AQ("AQ", "ATA", "010", "ISO 3166-2:AQ"),
    /**
     * Antigua and Barbuda
     */
    AG("AG", "ATG", "028", "ISO 3166-2:AG"),
    /**
     * Argentina
     */
    AR("AR", "ARG", "032", "ISO 3166-2:AR"),
    /**
     * Armenia
     */
    AM("AM", "ARM", "051", "ISO 3166-2:AM"),
    /**
     * Aruba
     */
    AW("AW", "ABW", "533", "ISO 3166-2:AW"),
    /**
     * Australia
     */
    AU("AU", "AUS", "036", "ISO 3166-2:AU"),
    /**
     * Austia
     */
    AT("AT", "AUT", "040", "ISO 3166-2:AT"),
    /**
     * Azerbaijan
     */
    AZ("AZ", "AZE", "031", "ISO 3166-2:AZ"),
    /**
     * Bahamas
     */
    BS("BS", "BHS", "044", "ISO 3166-2:BS"),
    /**
     * Bahrain
     */
    BH("BH", "BHR", "048", "ISO 3166-2:BH"),
    /**
     * Bangladesh
     */
    BD("BD", "BGD", "050", "ISO 3166-2:BD"),
    /**
     * Barbados
     */
    BB("BB", "BRB", "052", "ISO 3166-2:BB"),
    /**
     * Belarus
     */
    BY("BY", "BLR", "112", "ISO 3166-2:BY"),
    /**
     * Belgium
     */
    BE("BE", "BEL", "056", "ISO 3166-2:BE"),
    /**
     * Belize
     */
    BZ("BZ", "BLZ", "084", "ISO 3166-2:BZ"),
    /**
     * Benin
     */
    BJ("BJ", "BEN", "204", "ISO 3166-2:BJ"),
    /**
     * Bermuda
     */
    BM("BM", "BMU", "060", "ISO 3166-2:BM"),
    /**
     * Bhutan
     */
    BT("BT", "BTN", "064", "ISO 3166-2:BT"),
    /**
     * Bolivia, Plurinational State of
     */
    BO("BO", "BOL", "068", "ISO 3166-2:BO"),
    /**
     * Bonaire, Sint Eustatius and Saba
     */
    BQ("BQ", "BES", "535", "ISO 3166-2:BQ"),
    /**
     * Bosnia and Herzegovina
     */
    BA("BA", "BIH", "070", "ISO 3166-2:BA"),
    /**
     * Botswana
     */
    BW("BW", "BWA", "072", "ISO 3166-2:BW"),
    /**
     * Bouvet Island
     */
    BV("BV", "BVT", "074", "ISO 3166-2:BV"),
    /**
     * Brazil
     */
    BR("BR", "BRA", "076", "ISO 3166-2:BR"),
    /**
     * British Indian Ocean Territory
     */
    IO("IO", "IOT", "086", "ISO 3166-2:IO"),
    /**
     * Brunei Darussalam
     */
    BN("BN", "BRN", "096", "ISO 3166-2:BN"),
    /**
     * Bulgaria
     */
    BG("BG", "BGR", "100", "ISO 3166-2:BG"),
    /**
     * Burkina Faso
     */
    BF("BF", "BFA", "854", "ISO 3166-2:BF"),
    /**
     * Burundi
     */
    BI("BI", "BDI", "108", "ISO 3166-2:BI"),
    /**
     * Cambodia
     */
    KH("KH", "KHM", "116", "ISO 3166-2:KH"),
    /**
     * Cameroon
     */
    CM("CM", "CMR", "120", "ISO 3166-2:CM"),
    /**
     * Canada
     */
    CA("CA", "CAN", "124", "ISO 3166-2:CA"),
    /**
     * Cape Verde
     */
    CV("CV", "CPV", "132", "ISO 3166-2:CV"),
    /**
     * Cayman Islands
     */
    KY("KY", "CYM", "136", "ISO 3166-2:KY"),
    /**
     * Central African Republic
     */
    CF("CF", "CAF", "140", "ISO 3166-2:CF"),
    /**
     * Chad
     */
    TD("TD", "TCD", "148", "ISO 3166-2:TD"),
    /**
     * Chile
     */
    CL("CL", "CHL", "152", "ISO 3166-2:CL"),
    /**
     * China
     */
    CN("CN", "CHN", "156", "ISO 3166-2:CN"),
    /**
     * Cristmas Islands
     */
    CX("CX", "CXR", "162", "ISO 3166-2:CX"),
    /**
     * Cocos (Keeling) Islands
     */
    CC("CC", "CCK", "166", "ISO 3166-2:CC"),
    /**
     * Colombia
     */
    CO("CO", "COL", "170", "ISO 3166-2:CO"),
    /**
     * Comoros
     */
    KM("KM", "COM", "174", "ISO 3166-2:KM"),
    /**
     * Congo
     */
    CG("CG", "COG", "178", "ISO 3166-2:CG"),
    /**
     * Congo, the Democratic Republic of the
     */
    CD("CD", "COD", "180", "ISO 3166-2:CD"),
    /**
     * Cook Islands
     */
    CK("CK", "COK", "184", "ISO 3166-2:CK"),
    /**
     * Costa Rica
     */
    CR("CR", "CRI", "188", "ISO 3166-2:CR"),
    /**
     * Côte d'Ivoire
     */
    CI("CI", "CIV", "384", "ISO 3166-2:CI"),
    /**
     * Croatia
     */
    HR("HR", "HRV", "191", "ISO 3166-2:HR"),
    /**
     * Cuba
     */
    CU("CU", "CUB", "192", "ISO 3166-2:CU"),
    /**
     * Curaçao
     */
    CW("CW", "CUW", "531", "ISO 3166-2:CW"),
    /**
     * Cyprus
     */
    CY("CY", "CYP", "196", "ISO 3166-2:CY"),
    /**
     * Czech Republic
     */
    CZ("CZ", "CZE", "203", "ISO 3166-2:CZ"),
    /**
     * Denmark
     */
    DK("DK", "DNK", "208", "ISO 3166-2:DK"),
    /**
     * Djibouti
     */
    DJ("DJ", "DJI", "262", "ISO 3166-2:DJ"),
    /**
     * Dominica
     */
    DM("DM", "DMA", "212", "ISO 3166-2:DM"),
    /**
     * Dominican Republic
     */
    DO("DO", "DOM", "214", "ISO 3166-2:DO"),
    /**
     * Ecuador
     */
    EC("EC", "ECU", "218", "ISO 3166-2:EC"),
    /**
     * Egypt
     */
    EG("EG", "EGY", "818", "ISO 3166-2:EG"),
    /**
     * El Salvador
     */
    SV("SV", "SLV", "222", "ISO 3166-2:SV"),
    /**
     * Equatorial Guinea
     */
    GQ("GQ", "GNQ", "226", "ISO 3166-2:GQ"),
    /**
     * Eritrea
     */
    ER("ER", "ERI", "232", "ISO 3166-2:ER"),
    /**
     * Estonia
     */
    EE("EE", "EST", "233", "ISO 3166-2:EE"),
    /**
     * Ethiopia
     */
    ET("ET", "ETH", "231", "ISO 3166-2:ET"),
    /**
     * Falkland Islands (Malvinas)
     */
    FK("FK", "FLK", "238", "ISO 3166-2:FK"),
    /**
     * Faroe Islands
     */
    FO("FO", "FRO", "234", "ISO 3166-2:FO"),
    /**
     * Fiji
     */
    FJ("FJ", "FJI", "242", "ISO 3166-2:FJ"),
    /**
     * Finland
     */
    FI("FI", "FIN", "246", "ISO 3166-2:FI"),
    /**
     * France
     */
    FR("FR", "FRA", "250", "ISO 3166-2:FR"),
    /**
     * French Guiana
     */
    GF("GF", "GUF", "254", "ISO 3166-2:GF"),
    /**
     * French Polynesia
     */
    PF("PF", "PYF", "258", "ISO 3166-2:PF"),
    /**
     * French Southern Territories
     */
    TF("TF", "ATF", "260", "ISO 3166-2:TF"),
    /**
     * Gabon
     */
    GA("GA", "GAB", "266", "ISO 3166-2:GA"),
    /**
     * Gambia
     */
    GM("GM", "GMB", "270", "ISO 3166-2:GM"),
    /**
     * Georgia
     */
    GE("GE", "GEO", "268", "ISO 3166-2:GE"),
    /**
     * Germany
     */
    DE("DE", "DEU", "276", "ISO 3166-2:DE"),
    /**
     * Ghana
     */
    GH("GH", "GHA", "288", "ISO 3166-2:GH"),
    /**
     * Gibraltar
     */
    GI("GI", "GIB", "292", "ISO 3166-2:GI"),
    /**
     * Greece
     */
    GR("GR", "GRC", "300", "ISO 3166-2:GR"),
    /**
     * Greenland
     */
    GL("GL", "GRL", "304", "ISO 3166-2:GL"),
    /**
     * Grenada
     */
    GD("GD", "GRD", "308", "ISO 3166-2:GD"),
    /**
     * Guadeloupe
     */
    GP("GP", "GLP", "312", "ISO 3166-2:GP"),
    /**
     * Guam
     */
    GU("GU", "GUM", "316", "ISO 3166-2:GU"),
    /**
     * Guatemala
     */
    GT("GT", "GTM", "320", "ISO 3166-2:GT"),
    /**
     * Guernsey
     */
    GG("GG", "GGY", "831", "ISO 3166-2:GG"),
    /**
     * Guinea
     */
    GN("GN", "GIN", "324", "ISO 3166-2:GN"),
    /**
     * Guinea-Bissau
     */
    GW("GW", "GNB", "624", "ISO 3166-2:GW"),
    /**
     * Guyana
     */
    GY("GY", "GUY", "328", "ISO 3166-2:GY"),
    /**
     * Haiti
     */
    HT("HT", "HTI", "332", "ISO 3166-2:HT"),
    /**
     * Heard Island and McDonald Islands
     */
    HM("HM", "HMD", "334", "ISO 3166-2:HM"),
    /**
     * Holy See (Vatican City State)
     */
    VA("VA", "VAT", "336", "ISO 3166-2:VA"),
    /**
     * Honduras
     */
    HN("HN", "HND", "340", "ISO 3166-2:HN"),
    /**
     * Hong Kong
     */
    HK("HK", "HKG", "344", "ISO 3166-2:HK"),
    /**
     * Hungary
     */
    HU("HU", "HUN", "348", "ISO 3166-2:HU"),
    /**
     * Iceland
     */
    IS("IS", "ISL", "352", "ISO 3166-2:IS"),
    /**
     * India
     */
    IN("IN", "IND", "356", "ISO 3166-2:IN"),
    /**
     * Indonesia
     */
    ID("ID", "IDN", "360", "ISO 3166-2:ID"),
    /**
     * Iran, Islamic Republic of
     */
    IR("IR", "IRN", "364", "ISO 3166-2:IR"),
    /**
     * Iraq
     */
    IQ("IQ", "IRQ", "368", "ISO 3166-2:IQ"),
    /**
     * Ireland
     */
    IE("IE", "IRL", "372", "ISO 3166-2:IE"),
    /**
     * Isle of Man
     */
    IM("IM", "IMN", "833", "ISO 3166-2:IM"),
    /**
     * Israel
     */
    IL("IL", "ISR", "376", "ISO 3166-2:IL"),
    /**
     * Italy
     */
    IT("IT", "ITA", "380", "ISO 3166-2:IT"),
    /**
     * Jamaica
     */
    JM("JM", "JAM", "388", "ISO 3166-2:JM"),
    /**
     * Japan
     */
    JP("JP", "JPN", "392", "ISO 3166-2:JP"),
    /**
     * Jersey
     */
    JE("JE", "JEY", "832", "ISO 3166-2:JE"),
    /**
     * Jordan
     */
    JO("JO", "JOR", "400", "ISO 3166-2:JO"),
    /**
     * Kazakhstan
     */
    KZ("KZ", "KAZ", "398", "ISO 3166-2:KZ"),
    /**
     * Kenya
     */
    KE("KE", "KEN", "404", "ISO 3166-2:KE"),
    /**
     * Kiribati
     */
    KI("KI", "KIR", "296", "ISO 3166-2:KI"),
    /**
     * Korea, Democratic People's Republic of
     */
    KP("KP", "PRK", "408", "ISO 3166-2:KP"),
    /**
     * Korea, Republic of
     */
    KR("KR", "KOR", "410", "ISO 3166-2:KR"),
    /**
     * Kuwait
     */
    KW("KW", "KWT", "414", "ISO 3166-2:KW"),
    /**
     * Kyrgyzstan
     */
    KG("KG", "KGZ", "417", "ISO 3166-2:KG"),
    /**
     * Lao People's Democratic Republic
     */
    LA("LA", "LAO", "418", "ISO 3166-2:LA"),
    /**
     * Latvia
     */
    LV("LV", "LVA", "428", "ISO 3166-2:LV"),
    /**
     * Lebanon
     */
    LB("LB", "LBN", "422", "ISO 3166-2:LB"),
    /**
     * Lesotho
     */
    LS("LS", "LSO", "426", "ISO 3166-2:LS"),
    /**
     * Liberia
     */
    LR("LR", "LBR", "430", "ISO 3166-2:LR"),
    /**
     * Libya
     */
    LY("LY", "LBY", "434", "ISO 3166-2:LY"),
    /**
     * Liechtenstein
     */
    LI("LI", "LIE", "438", "ISO 3166-2:LI"),
    /**
     * Lithuania
     */
    LT("LT", "LTU", "440", "ISO 3166-2:LT"),
    /**
     * Luxembourg
     */
    LU("LU", "LUX", "442", "ISO 3166-2:LU"),
    /**
     * Macao
     */
    MO("MO", "MAC", "446", "ISO 3166-2:MO"),
    /**
     * Macedonia, the former Yugoslav Republic of
     */
    MK("MK", "MKD", "807", "ISO 3166-2:MK"),
    /**
     * Madagascar
     */
    MG("MG", "MDG", "450", "ISO 3166-2:MG"),
    /**
     * Malawi
     */
    MW("MW", "MWI", "454", "ISO 3166-2:MW"),
    /**
     * Malaysia
     */
    MY("MY", "MYS", "458", "ISO 3166-2:MY"),
    /**
     * Maldives
     */
    MV("MV", "MDV", "462", "ISO 3166-2:MV"),
    /**
     * Mali
     */
    ML("ML", "MLI", "466", "ISO 3166-2:ML"),
    /**
     * Malta
     */
    MT("MT", "MLT", "470", "ISO 3166-2:MT"),
    /**
     * Marshall Islands
     */
    MH("MH", "MHL", "584", "ISO 3166-2:MH"),
    /**
     * Martinique
     */
    MQ("MQ", "MTQ", "474", "ISO 3166-2:MQ"),
    /**
     * Mauritania
     */
    MR("MR", "MRT", "478", "ISO 3166-2:MR"),
    /**
     * Mauritius
     */
    MU("MU", "MUS", "480", "ISO 3166-2:MU"),
    /**
     * Mayotte
     */
    YT("YT", "MYT", "175", "ISO 3166-2:YT"),
    /**
     * Mexico
     */
    MX("MX", "MEX", "484", "ISO 3166-2:MX"),
    /**
     * Micronesia, Federated States of
     */
    FM("FM", "FSM", "583", "ISO 3166-2:FM"),
    /**
     * Moldova, Republic of
     */
    MD("MD", "MDA", "498", "ISO 3166-2:MD"),
    /**
     * Monaco
     */
    MC("MC", "MCO", "492", "ISO 3166-2:MC"),
    /**
     * Mongolia
     */
    MN("MN", "MNG", "496", "ISO 3166-2:MN"),
    /**
     * Montenegro
     */
    ME("ME", "MNE", "499", "ISO 3166-2:ME"),
    /**
     * Montserrat
     */
    MS("MS", "MSR", "500", "ISO 3166-2:MS"),
    /**
     * Morocco
     */
    MA("MA", "MAR", "504", "ISO 3166-2:MA"),
    /**
     * Mozambique
     */
    MZ("MZ", "MOZ", "508", "ISO 3166-2:MZ"),
    /**
     * Myanmar
     */
    MM("MM", "MMR", "104", "ISO 3166-2:MM"),
    /**
     * Namibia
     */
    NA("NA", "NAM", "516", "ISO 3166-2:NA"),
    /**
     * Nauru
     */
    NR("NR", "NRU", "520", "ISO 3166-2:NR"),
    /**
     * Nepal
     */
    NP("NP", "NPL", "524", "ISO 3166-2:NP"),
    /**
     * Netherlands
     */
    NL("NL", "NLD", "528", "ISO 3166-2:NL"),
    /**
     * New Caledonia
     */
    NC("NC", "NCL", "540", "ISO 3166-2:NC"),
    /**
     * New Zealand
     */
    NZ("NZ", "NZL", "554", "ISO 3166-2:NZ"),
    /**
     * Nicaragua
     */
    NI("NI", "NIC", "558", "ISO 3166-2:NI"),
    /**
     * Niger
     */
    NE("NE", "NER", "562", "ISO 3166-2:NE"),
    /**
     * Nigeria
     */
    NG("NG", "NGA", "566", "ISO 3166-2:NG"),
    /**
     * Niue
     */
    NU("NU", "NIU", "570", "ISO 3166-2:NU"),
    /**
     * Norfolk Island
     */
    NF("NF", "NFK", "574", "ISO 3166-2:NF"),
    /**
     * Northern Mariana Islands
     */
    MP("MP", "MNP", "580", "ISO 3166-2:MP"),
    /**
     * Norway
     */
    NO("NO", "NOR", "578", "ISO 3166-2:NO"),
    /**
     * Oman
     */
    OM("OM", "OMN", "512", "ISO 3166-2:OM"),
    /**
     * Pakistan
     */
    PK("PK", "PAK", "586", "ISO 3166-2:PK"),
    /**
     * Palau
     */
    PW("PW", "PLW", "585", "ISO 3166-2:PW"),
    /**
     * Palestinian Territory, Occupied
     */
    PS("PS", "PSE", "275", "ISO 3166-2:PS"),
    /**
     * Panama
     */
    PA("PA", "PAN", "591", "ISO 3166-2:PA"),
    /**
     * Papua New Guinea
     */
    PG("PG", "PNG", "598", "ISO 3166-2:PG"),
    /**
     * Paraguay
     */
    PY("PY", "PRY", "600", "ISO 3166-2:PY"),
    /**
     * Peru
     */
    PE("PE", "PER", "604", "ISO 3166-2:PE"),
    /**
     * Philippines
     */
    PH("PH", "PHL", "608", "ISO 3166-2:PH"),
    /**
     * Pitcairn
     */
    PN("PN", "PCN", "612", "ISO 3166-2:PN"),
    /**
     * Poland
     */
    PL("PL", "POL", "616", "ISO 3166-2:PL"),
    /**
     * Portugal
     */
    PT("PT", "PRT", "620", "ISO 3166-2:PT"),
    /**
     * Puerto Rico
     */
    PR("PR", "PRI", "630", "ISO 3166-2:PR"),
    /**
     * Qatar
     */
    QA("QA", "QAT", "634", "ISO 3166-2:QA"),
    /**
     * Réunion
     */
    RE("RE", "REU", "638", "ISO 3166-2:RE"),
    /**
     * Romania
     */
    RO("RO", "ROU", "642", "ISO 3166-2:RO"),
    /**
     * Russian Federation
     */
    RU("RU", "RUS", "643", "ISO 3166-2:RU"),
    /**
     * Rwanda
     */
    RW("RW", "RWA", "646", "ISO 3166-2:RW"),
    /**
     * Saint Barthélemy
     */
    BL("BL", "BLM", "652", "ISO 3166-2:BL"),
    /**
     * Saint Helena, Ascension and Tristan da Cunha
     */
    SH("SH", "SHN", "654", "ISO 3166-2:SH"),
    /**
     * Saint Kitts and Nevis
     */
    KN("KN", "KNA", "659", "ISO 3166-2:KN"),
    /**
     * Saint Lucia
     */
    LC("LC", "LCA", "662", "ISO 3166-2:LC"),
    /**
     * Saint Martin (French part)
     */
    MF("MF", "MAF", "663", "ISO 3166-2:MF"),
    /**
     * Saint Pierre and Miquelon
     */
    PM("PM", "SPM", "666", "ISO 3166-2:PM"),
    /**
     * Saint Vincent and the Grenadines
     */
    VC("VC", "VCT", "670", "ISO 3166-2:VC"),
    /**
     * Samoa
     */
    WS("WS", "WSM", "882", "ISO 3166-2:WS"),
    /**
     * San Marino
     */
    SM("SM", "SMR", "674", "ISO 3166-2:SM"),
    /**
     * Sao Tome and Principe
     */
    ST("ST", "STP", "678", "ISO 3166-2:ST"),
    /**
     * Saudi Arabia
     */
    SA("SA", "SAU", "682", "ISO 3166-2:SA"),
    /**
     * Senegal
     */
    SN("SN", "SEN", "686", "ISO 3166-2:SN"),
    /**
     * Serbia
     */
    RS("RS", "SRB", "688", "ISO 3166-2:RS"),
    /**
     * Seychelles
     */
    SC("SC", "SYC", "690", "ISO 3166-2:SC"),
    /**
     * Sierra Leone
     */
    SL("SL", "SLE", "694", "ISO 3166-2:SL"),
    /**
     * Singapore
     */
    SG("SG", "SGP", "702", "ISO 3166-2:SG"),
    /**
     * Sint Maarten (Dutch part)
     */
    SX("SX", "SXM", "534", "ISO 3166-2:SX"),
    /**
     * Slovakia
     */
    SK("SK", "SVK", "703", "ISO 3166-2:SK"),
    /**
     * Slovenia
     */
    SI("SI", "SVN", "705", "ISO 3166-2:SI"),
    /**
     * Solomon Islands
     */
    SB("SB", "SLB", "090", "ISO 3166-2:SB"),
    /**
     * Somalia
     */
    SO("SO", "SOM", "706", "ISO 3166-2:SO"),
    /**
     * South Africa
     */
    ZA("ZA", "ZAF", "710", "ISO 3166-2:ZA"),
    /**
     * South Georgia and the South Sandwich Islands
     */
    GS("GS", "SGS", "239", "ISO 3166-2:GS"),
    /**
     * South Sudan
     */
    SS("SS", "SSD", "728", "ISO 3166-2:SS"),
    /**
     * Spain
     */
    ES("ES", "ESP", "724", "ISO 3166-2:ES"),
    /**
     * Sri Lanka
     */
    LK("LK", "LKA", "144", "ISO 3166-2:LK"),
    /**
     * Sudan
     */
    SD("SD", "SDN", "729", "ISO 3166-2:SD"),
    /**
     * Suriname
     */
    SR("SR", "SUR", "740", "ISO 3166-2:SR"),
    /**
     * Svalbard and Jan Mayen
     */
    SJ("SJ", "SJM", "744", "ISO 3166-2:SJ"),
    /**
     * Swaziland
     */
    SZ("SZ", "SWZ", "748", "ISO 3166-2:SZ"),
    /**
     * Sweden
     */
    SE("SE", "SWE", "752", "ISO 3166-2:SE"),
    /**
     * Switzerland
     */
    CH("CH", "CHE", "756", "ISO 3166-2:CH"),
    /**
     * Syrian Arab Republic
     */
    SY("SY", "SYR", "760", "ISO 3166-2:SY"),
    /**
     * Taiwan, Province of China
     */
    TW("TW", "TWN", "158", "ISO 3166-2:TW"),
    /**
     * Tajikistan
     */
    TJ("TJ", "TJK", "762", "ISO 3166-2:TJ"),
    /**
     * Tanzania, United Republic of
     */
    TZ("TZ", "TZA", "834", "ISO 3166-2:TZ"),
    /**
     * Thailand
     */
    TH("TH", "THA", "764", "ISO 3166-2:TH"),
    /**
     * Timor-Leste
     */
    TL("TL", "TLS", "626", "ISO 3166-2:TL"),
    /**
     * Togo
     */
    TG("TG", "TGO", "768", "ISO 3166-2:TG"),
    /**
     * Tokelau
     */
    TK("TK", "TKL", "772", "ISO 3166-2:TK"),
    /**
     * Tonga
     */
    TO("TO", "TON", "776", "ISO 3166-2:TO"),
    /**
     * Trinidad and Tobago
     */
    TT("TT", "TTO", "780", "ISO 3166-2:TT"),
    /**
     * Tunisia
     */
    TN("TN", "TUN", "788", "ISO 3166-2:TN"),
    /**
     * Turkey
     */
    TR("TR", "TUR", "792", "ISO 3166-2:TR"),
    /**
     * Turkmenistan
     */
    TM("TM", "TKM", "795", "ISO 3166-2:TM"),
    /**
     * Turks and Caicos Islands
     */
    TC("TC", "TCA", "796", "ISO 3166-2:TC"),
    /**
     * Tuvalu
     */
    TV("TV", "TUV", "798", "ISO 3166-2:TV"),
    /**
     * Uganda
     */
    UG("UG", "UGA", "800", "ISO 3166-2:UG"),
    /**
     * Ukraine
     */
    UA("UA", "UKR", "804", "ISO 3166-2:UA"),
    /**
     * United Arab Emirates
     */
    AE("AE", "ARE", "784", "ISO 3166-2:AE"),
    /**
     * United Kingdom
     */
    GB("GB", "GBR", "826", "ISO 3166-2:GB"),
    /**
     * United States
     */
    US("US", "USA", "840", "ISO 3166-2:US"),
    /**
     * United States Minor Outlying Islands
     */
    UM("UM", "UMI", "581", "ISO 3166-2:UM"),
    /**
     * Uruguay
     */
    UY("UY", "URY", "858", "ISO 3166-2:UY"),
    /**
     * Uzbekistan
     */
    UZ("UZ", "UZB", "860", "ISO 3166-2:UZ"),
    /**
     * Vanuatu
     */
    VU("VU", "VUT", "548", "ISO 3166-2:VU"),
    /**
     * Venezuela, Bolivarian Republic of
     */
    VE("VE", "VEN", "862", "ISO 3166-2:VE"),
    /**
     * Viet Nam
     */
    VN("VN", "VNM", "704", "ISO 3166-2:VN"),
    /**
     * Virgin Islands, British
     */
    VG("VG", "VGB", "092", "ISO 3166-2:VG"),
    /**
     * Virgin Islands, U.S.
     */
    VI("VI", "VIR", "850", "ISO 3166-2:VI"),
    /**
     * Wallis and Futuna
     */
    WF("WF", "WLF", "876", "ISO 3166-2:WF"),
    /**
     * Western Sahara
     */
    EH("EH", "ESH", "732", "ISO 3166-2:EH"),
    /**
     * Yemen
     */
    YE("YE", "YEM", "887", "ISO 3166-2:YE"),
    /**
     * Zambia
     */
    ZM("ZM", "ZMB", "894", "ISO 3166-2:ZM"),
    /**
     * Zimbabwe
     */
    ZW("ZW", "ZWE", "716", "ISO 3166-2:ZW");
    private String name;
    private String alpha2;
    private String alpha3;
    private String numericCode;
    private String ISO3166_2Code;
    private final String BUNDLE_PREFIX = "Country ";

    private Country(String alpha2, String alpha3, String numbericCode, String ISO3166_2Code) {
        this.name = !alpha2.isEmpty() ? NbBundle.getMessage(getClass(), BUNDLE_PREFIX + alpha2) : "";
        this.alpha2 = alpha2;
        this.alpha3 = alpha3;
        this.numericCode = numbericCode;
        this.ISO3166_2Code = ISO3166_2Code;
    }

    /**
     * Get the ISO 3166-2 code. It is part of the ISO 3166 standard published by
     * the International Organization for Standardization (ISO), and defines
     * codes for the names of the principal subdivisions (e.g., provinces or
     * states) of all countries coded in ISO 3166-1.
     *
     * @return
     */
    public String getISO3166_2Code() {
        return ISO3166_2Code;
    }

    /**
     * Get the ISO 3166-1 alpha-2 code which are two-letter country codes
     * defined in ISO 3166-1, part of the ISO 3166 standard published by the
     * International Organization for Standardization (ISO), to represent
     * countries, dependent territories, and special areas of geographical
     * interest.
     *
     * @return the alpha-2 code for this country
     */
    public String getAlpha2() {
        return alpha2;
    }

    /**
     * Get the ISO 3166-1 alpha-3 code which are three-letter country codes
     * defined in ISO 3166-1, part of the ISO 3166 standard published by the
     * International Organization for Standardization (ISO), to represent
     * countries, dependent territories, and special areas of geographical
     * interest. They allow a better visual association between the codes and
     * the country names than the two-letter alpha-2 codes
     *
     * @return the Alpha-3 code for a country
     */
    public String getAlpha3() {
        return alpha3;
    }

    /**
     * Get the name of a country The name of the country is read from a bundle
     * file
     *
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * Get the ISO 3166-1 numeric (or numeric-3) code which are three-digit
     * country codes defined in ISO 3166-1, part of the ISO 3166 standard
     * published by the International Organization for Standardization (ISO), to
     * represent countries, dependent territories, and special areas of
     * geographical interest. They are identical to the three-digit country
     * codes developed and maintained by the United Nations Statistics Division,
     * from which they originate in its UN M.49 standard.
     *
     * @return the numeric code for a country
     */
    public String getNumericCode() {
        return numericCode;
    }

    /**
     * Returns a string containing the {@link Country#name}
     */
    @Override
    public String toString() {
        return getName();
    }
    
    public static Comparator<Country> getNameComparator() {
        return new Comparator<Country>() {
            @Override
            public int compare(Country o1, Country o2) {
                return o1.getName().compareTo(o2.getName());
            }
        };
    }
}
